Package org.apache.sysds.runtime.compress.colgroup

# Class ColGroupOLE

java.lang.Object
org.apache.sysds.runtime.compress.colgroup.AColGroup
org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed
org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup
org.apache.sysds.runtime.compress.colgroup.AColGroupValue
org.apache.sysds.runtime.compress.colgroup.APreAgg
org.apache.sysds.runtime.compress.colgroup.AColGroupOffset
org.apache.sysds.runtime.compress.colgroup.ColGroupOLE

All Implemented Interfaces:
  `Serializable`, `IContainADictionary`

public class ColGroupOLE extends AColGroupOffset
Class to encapsulate information about a column group that is encoded with simple lists of offsets for each set of distinct values.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`AColGroup.CompressionType`

## Method Summary

Modifier and Type
Method
Description
`AColGroup`
`append(AColGroup g)`
Append the other column group to this column group.
`AColGroup`
`appendNInternal(AColGroup[] g, int blen, int rlen)`
`AColGroup`
`binaryRowOpLeft(BinaryOperator op, double[] v, boolean isRowSafe)`
Perform a binary row operation.
`AColGroup`
`binaryRowOpRight(BinaryOperator op, double[] v, boolean isRowSafe)`
Perform a binary row operation.
`boolean`
`containsValue(double pattern)`
Detect if the column group contains a specific value.
`static char[]`
`genOffsetBitmap(int[] offsets, int len)`
Encodes the bitmap in blocks of offsets.
`org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType`
`getColGroupType()`
`CompressedSizeInfoColGroup`
`getCompressionInfo(int nRow)`
Get the compression info for this column group.
`ICLAScheme`
`getCompressionScheme()`
Get the compression scheme for this column group to enable compression of other data.
`AColGroup.CompressionType`
`getCompType()`
Obtain the compression type.
`double`
`getCost(ComputationCostEstimator e, int nRows)`
Get the computation cost associated with this column group.
`int[]`
`getCounts(int[] counts)`
`double`
`getIdx(int r, int colIdx)`
Get the value at a colGroup specific row/column index position.
`void`
`leftMMIdentityPreAggregateDense(MatrixBlock that, MatrixBlock ret, int rl, int ru, int cl, int cu)`
`void`
`leftMultByMatrixNoPreAgg(MatrixBlock matrix, MatrixBlock result, int rl, int ru, int cl, int cu)`
Left multiply with this column group.
`void`
`preAggregateDense(MatrixBlock m, double[] preAgg, int rl, int ru, int cl, int cu)`
Pre aggregate a dense matrix block into a pre aggregate target (first step of left matrix multiplication)
`void`
`preAggregateSparse(SparseBlock sb, double[] preAgg, int rl, int ru, int cl, int cu)`
`static ColGroupOLE`
`read(DataInput in, int nRows)`
`AColGroup`
`recompress()`
Recompress this column group into a new column group.
`AColGroup`
`removeEmptyRows(boolean[] selectV, int rOut)`
Return a new column group containing only the selected rows in the given boolean vector.
`boolean`
`sameIndexStructure(AColGroupCompressed that)`
`AColGroup`
`scalarOperation(ScalarOperator op)`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.
`AColGroup`
`sliceRows(int rl, int ru)`
Slice range of rows out of the column group and return a new column group only containing the row segment.
`AColGroup`
`sort()`
Sort the values of the column group according to double comparison operations and return as another compressed group.
`AColGroup[]`
`splitReshape(int multiplier, int nRow, int nColOrg)`
This method returns a list of column groups that are naive splits of this column group as if it is reshaped.
`String`
`toString()`
`AColGroup`
`unaryOperation(UnaryOperator op)`
Perform unary operation on the column group and return a new column group

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupOffset

`containZerosTuples, estimateInMemorySize, getExactSizeOnDisk, readData, readPointers, write`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.APreAgg

`getPreAggregateSize, leftMultByAColGroup, mmWithDictionary, preAggregate, preAggregateThatIndexStructure, tsmmAColGroup`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupValue

`centralMoment, clear, computeColSums, getCounts, getNumberNonZeros, getNumValues, replace, rexpandCols`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup

`copyAndSet, copyAndSet, decompressToDenseBlock, decompressToDenseBlockTransposed, decompressToSparseBlock, decompressToSparseBlockTransposed, getDictionary, getSparsity, reduceCols, rightMultByMatrix`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed

`getMax, getMin, getSum, isEmpty, preAggRows, sameIndexStructure, tsmm, unaryAggregateOperations, unaryAggregateOperations`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`addVector, appendN, colSum, combine, combineWithSameIndex, combineWithSameIndex, decompressToDenseBlock, decompressToSparseBlock, get, getColIndices, getEncoding, getNumCols, morph, removeEmptyCols, rightDecompressingMult, rightMultByMatrix, selectionMultiply, shiftColIndices, sliceColumn, sliceColumns, sortColumnIndexes, splitReshapePushDown`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Method Details

### getCompType

public AColGroup.CompressionType getCompType()
Description copied from class: `AColGroup`
Obtain the compression type.

Specified by:
  `getCompType` in class `AColGroup`
Returns:
  How the elements of the column group are compressed.

### getColGroupType

public org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType getColGroupType()

### getCounts

public int[] getCounts(int[] counts)

### scalarOperation

public AColGroup scalarOperation(ScalarOperator op)
Description copied from class: `AColGroup`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.

Specified by:
  `scalarOperation` in class `AColGroup`
Parameters:
  `op` - operation to perform
Returns:
  version of this column group with the operation applied

### unaryOperation

public AColGroup unaryOperation(UnaryOperator op)
Description copied from class: `AColGroup`
Perform unary operation on the column group and return a new column group

Specified by:
  `unaryOperation` in class `AColGroup`
Parameters:
  `op` - The operation to perform
Returns:
  The new column group

### binaryRowOpLeft

public AColGroup binaryRowOpLeft(BinaryOperator op, double[] v, boolean isRowSafe)
Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpLeft` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply the values contained should be at least the length of the highest value in the column index
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

### binaryRowOpRight

public AColGroup binaryRowOpRight(BinaryOperator op, double[] v, boolean isRowSafe)
Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpRight` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply the values contained should be at least the length of the highest value in the column index
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

### getIdx

public double getIdx(int r, int colIdx)
Description copied from class: `AColGroup`
Get the value at a colGroup specific row/column index position.

Specified by:
  `getIdx` in class `AColGroup`
Parameters:
  `r` - row
  `colIdx` - column index in the _colIndexes.
Returns:
  value at the row/column index position

### leftMultByMatrixNoPreAgg

public void leftMultByMatrixNoPreAgg(MatrixBlock matrix, MatrixBlock result, int rl, int ru, int cl, int cu)
Description copied from class: `AColGroup`
Left multiply with this column group.

Specified by:
  `leftMultByMatrixNoPreAgg` in class `AColGroup`
Parameters:
  `matrix` - The matrix to multiply with on the left
  `result` - The result to output the values into, always dense for the purpose of the column groups parallelizing
  `rl` - The row to begin the multiplication from on the lhs matrix
  `ru` - The row to end the multiplication at on the lhs matrix
  `cl` - The column to begin the multiplication from on the lhs matrix
  `cu` - The column to end the multiplication at on the lhs matrix

### containsValue

public boolean containsValue(double pattern)
Description copied from class: `AColGroup`
Detect if the column group contains a specific value.

Specified by:
  `containsValue` in class `AColGroup`
Parameters:
  `pattern` - The value to look for.
Returns:
  boolean saying true if the value is contained.

### toString

public String toString()

Overrides:
  `toString` in class `AColGroupValue`

### genOffsetBitmap

public static char[] genOffsetBitmap(int[] offsets, int len)
Encodes the bitmap in blocks of offsets. Within each block, the bits are stored as absolute offsets from the start of the block.

Parameters:
  `offsets` - uncompressed offset list
  `len` - logical length of the given offset list
Returns:
  compressed version of said bitmap

### preAggregateDense

public void preAggregateDense(MatrixBlock m, double[] preAgg, int rl, int ru, int cl, int cu)
Description copied from class: `APreAgg`
Pre aggregate a dense matrix block into a pre aggregate target (first step of left matrix multiplication)

Specified by:
  `preAggregateDense` in class `APreAgg`
Parameters:
  `m` - The matrix to preAggregate
  `preAgg` - The preAggregate target
  `rl` - Row lower on the left side matrix
  `ru` - Row upper on the left side matrix
  `cl` - Column lower on the left side matrix (or row lower in the column group)
  `cu` - Column upper on the left side matrix (or row upper in the column group)

### leftMMIdentityPreAggregateDense

public void leftMMIdentityPreAggregateDense(MatrixBlock that, MatrixBlock ret, int rl, int ru, int cl, int cu)

Specified by:
  `leftMMIdentityPreAggregateDense` in class `APreAgg`

### preAggregateSparse

public void preAggregateSparse(SparseBlock sb, double[] preAgg, int rl, int ru, int cl, int cu)

Specified by:
  `preAggregateSparse` in class `APreAgg`

### sameIndexStructure

public boolean sameIndexStructure(AColGroupCompressed that)

Specified by:
  `sameIndexStructure` in class `AColGroupCompressed`

### getCost

public double getCost(ComputationCostEstimator e, int nRows)
Description copied from class: `AColGroup`
Get the computation cost associated with this column group.

Specified by:
  `getCost` in class `AColGroup`
Parameters:
  `e` - The computation cost estimator
  `nRows` - the number of rows in the column group
Returns:
  The cost of this column group

### read

public static ColGroupOLE read(DataInput in, int nRows) throws IOException

Throws:
  `IOException`

### sliceRows

public AColGroup sliceRows(int rl, int ru)
Description copied from class: `AColGroup`
Slice range of rows out of the column group and return a new column group only containing the row segment. Note that this slice should maintain pointers back to the original dictionaries and only modify index structures.

Specified by:
  `sliceRows` in class `AColGroup`
Parameters:
  `rl` - The row to start at
  `ru` - The row to end at (not included)
Returns:
  A new column group containing the specified row range.

### append

public AColGroup append(AColGroup g)
Description copied from class: `AColGroup`
Append the other column group to this column group. This method tries to combine them to return a new column group containing both. In some cases it is possible in reasonable time, in others it is not. The result is first this column group followed by the other column group in higher row values. If it is not possible or very inefficient null is returned.

Specified by:
  `append` in class `AColGroup`
Parameters:
  `g` - The other column group
Returns:
  A combined column group or null

### appendNInternal

public AColGroup appendNInternal(AColGroup[] g, int blen, int rlen)

### getCompressionScheme

public ICLAScheme getCompressionScheme()
Description copied from class: `AColGroup`
Get the compression scheme for this column group to enable compression of other data.

Specified by:
  `getCompressionScheme` in class `AColGroup`
Returns:
  The compression scheme of this column group

### recompress

public AColGroup recompress()
Description copied from class: `AColGroup`
Recompress this column group into a new column group.

Specified by:
  `recompress` in class `AColGroup`
Returns:
  A new or the same column group depending on optimization goal.

### getCompressionInfo

public CompressedSizeInfoColGroup getCompressionInfo(int nRow)
Description copied from class: `AColGroup`
Get the compression info for this column group.

Specified by:
  `getCompressionInfo` in class `AColGroup`
Parameters:
  `nRow` - The number of rows in this column group.
Returns:
  The compression info for this group.

### splitReshape

public AColGroup[] splitReshape(int multiplier, int nRow, int nColOrg)
Description copied from class: `AColGroup`
This method returns a list of column groups that are naive splits of this column group as if it is reshaped. This means the column groups rows are split into x number of other column groups where x is the multiplier. The indexes are assigned round robbin to each of the output groups, meaning the first index is assigned. If for instance the 4. column group is split by a 2 multiplier and there was 5 columns in total originally. The output becomes 2 column groups at column index 4 and one at 9. If possible the split column groups should reuse pointers back to the original dictionaries!

Specified by:
  `splitReshape` in class `AColGroup`
Parameters:
  `multiplier` - The number of column groups to split into
  `nRow` - The number of rows in this column group in case the underlying column group does not know
  `nColOrg` - The number of overall columns in the host CompressedMatrixBlock.
Returns:
  a list of split column groups

### removeEmptyRows

public AColGroup removeEmptyRows(boolean[] selectV, int rOut)
Description copied from class: `AColGroup`
Return a new column group containing only the selected rows in the given boolean vector. Whenever possible only modify the index structure, not the dictionary of the column groups.

Specified by:
  `removeEmptyRows` in class `AColGroup`
Parameters:
  `selectV` - The selection vector
  `rOut` - The number of rows in the output
Returns:
  The new column group

### sort

public AColGroup sort()
Description copied from class: `AColGroup`
Sort the values of the column group according to double comparison operations and return as another compressed group. This sorting assumes that the column group is sorted independently of everything else.

Specified by:
  `sort` in class `AColGroup`
Returns:
  The sorted group